package common.village;

import java.util.ArrayList;

import common.collect.Lists;
import common.item.ItemStack;
import common.tags.TagObject;
import java.util.List;

public class MerchantRecipeList extends ArrayList<MerchantRecipe> {
	public MerchantRecipe canUse(ItemStack stack1, ItemStack stack2, int index) {
		if(index > 0 && index < this.size()) {
			MerchantRecipe recipe = this.get(index);
			return !areItemsSimilar(stack1, recipe.getBuying())
					|| (stack2 != null || recipe.hasSecondBuy())
							&& (!recipe.hasSecondBuy() || !areItemsSimilar(stack2, recipe.getSecondBuy()))
					|| stack1.size < recipe.getBuying().size
					|| recipe.hasSecondBuy() && stack2.size < recipe.getSecondBuy().size ? null : recipe;
		}
		else {
			for(int z = 0; z < this.size(); z++) {
				MerchantRecipe recipe = this.get(z);
				if(areItemsSimilar(stack1, recipe.getBuying()) && stack1.size >= recipe.getBuying().size
						&& (!recipe.hasSecondBuy() && stack2 == null
								|| recipe.hasSecondBuy() && areItemsSimilar(stack2, recipe.getSecondBuy())
										&& stack2.size >= recipe.getSecondBuy().size)) {
					return recipe;
				}
			}
			return null;
		}
	}

	private static boolean areItemsSimilar(ItemStack stack1, ItemStack stack2) {
		return ItemStack.areItemsEqual(stack1, stack2)
				&& (!stack2.hasTagCompound() || stack1.hasTagCompound() && TagObject.compare(stack2.getTagCompound(), stack1.getTagCompound()));
	}

	public void fromTags(List<TagObject> list) {
		this.clear();
		for(int z = 0; z < list.size(); z++) {
			this.add(new MerchantRecipe(list.get(z)));
		}
	}

	public List<TagObject> toTags() {
		List<TagObject> list = Lists.newArrayList();
		for(int z = 0; z < this.size(); z++) {
			list.add(this.get(z).toTags());
		}
		return list;
	}
}
